/*******************************************************************
 *
 * PERF.H - Performance Data Function Header File
 * Copyright (c) 2000 Ethan Galstad (netsaint@linuxbox.com)
 * Last Modified: 02-12-2000
 * License: GPL
 *
 * Credits: Most of the perfdata code is based on the code found
 *          int CDC's BackOrifice 2000.  See http://www.bo2k.com
 *			for more information.
 *
 ******************************************************************/


// Data definitions
typedef PERF_DATA_BLOCK             PERF_DATA,      *PPERF_DATA; 
typedef PERF_OBJECT_TYPE            PERF_OBJECT,    *PPERF_OBJECT; 
typedef PERF_INSTANCE_DEFINITION    PERF_INSTANCE,  *PPERF_INSTANCE; 
typedef PERF_COUNTER_DEFINITION     PERF_COUNTER,   *PPERF_COUNTER; 


// Function definitions
DWORD		GetPerfData (HKEY hPerfKey,LPTSTR szObjectIndex,PPERF_DATA *ppData,DWORD *pDataSize); 
PPERF_DATA	RefreshPerfData (HKEY hPerfKey,LPTSTR szObjectIndex,PPERF_DATA pData,DWORD *pDataSize);
 
DWORD		GetPerfTitleSz (HKEY hKeyMachine,HKEY hKeyPerf,LPTSTR *TitleBuffer,LPTSTR *TitleSz[],DWORD *TitleLastIdx); 
DWORD		GetTitleIdx(LPTSTR Title[], DWORD LastIndex, LPTSTR Name);
int			SetPerfIndexes(void);


// Perfomance data access functions
PPERF_OBJECT    FirstObject (PPERF_DATA pData); 
PPERF_OBJECT    NextObject (PPERF_OBJECT pObject); 
PPERF_OBJECT    FindObject (PPERF_DATA pData, DWORD TitleIndex); 
PPERF_OBJECT    FindObjectN (PPERF_DATA pData, DWORD N); 

PPERF_INSTANCE  FirstInstance (PPERF_OBJECT pObject); 
PPERF_INSTANCE  NextInstance (PPERF_INSTANCE pInst); 
PPERF_INSTANCE  FindInstanceN (PPERF_OBJECT pObject, DWORD N); 
PPERF_INSTANCE  FindInstanceParent (PPERF_INSTANCE pInst, PPERF_DATA pData); 
LPTSTR          InstanceName (PPERF_INSTANCE pInst); 
 
PPERF_COUNTER   FirstCounter (PPERF_OBJECT pObject); 
PPERF_COUNTER   NextCounter (PPERF_COUNTER pCounter); 
PPERF_COUNTER   FindCounter (PPERF_OBJECT pObject, DWORD TitleIndex); 
PVOID           CounterData (PPERF_INSTANCE pInst, PPERF_COUNTER pCount); 


// Sets focus for performance data
void	PerfData_SetLocalMachine(void);
int		PerfData_ConnectComputer(char *svName);


// Processor load calculation functions
void	PerfData_GetProcessorLoad(void);
void	calculate_processor_load(int);
void	calculate_average_processor_load(int);



// Perf objects we want to monitor
#define PN_PROCESSOR			TEXT("Processor")
#define PN_PROCESSOR_CPU		TEXT("% Processor Time") 
#define PN_PROCESSOR_PRIV		TEXT("% Privileged Time") 
#define PN_PROCESSOR_USER		TEXT("% User Time") 

DWORD PX_PROCESSOR;
DWORD PX_PROCESSOR_CPU;
DWORD PX_PROCESSOR_PRIV;
DWORD PX_PROCESSOR_USER;

